/* config.hin.  Generated automatically from configure.in by autoheader.  */
/* and modified extensively for VMS by several hands */

/* older compilers are better off using the OS version */
#if (!defined(__DECC_VER) || __DECC_VER < 50600000)
#   undef __CRTL_VER
#   define __CRTL_VER __VMS_VER
#endif

/* Define if on AIX 3.
   System headers sometimes define this.
   We just want to avoid a redefinition error message.  */
#ifndef _ALL_SOURCE
#undef _ALL_SOURCE
#endif

/* Define if the closedir function returns void instead of int.  */
#undef CLOSEDIR_VOID

/* Define to empty if the keyword does not work.  */
#undef const

/* Define if you don't have vprintf but do have _doprnt.  */
#undef HAVE_DOPRNT

/* Define if you support file names longer than 14 characters.  */
#define HAVE_LONG_FILE_NAMES 1

/* Define if you have the vprintf function.  */
#define HAVE_VPRINTF 1

/* Define if on MINIX.  */
#undef _MINIX

/* Define to `int' if <sys/types.h> doesn't define.  */
#undef mode_t

/* Define to `long' if <sys/types.h> doesn't define.  */
#undef off_t

/* Define to `int' if <sys/types.h> doesn't define.  */
#undef pid_t

/* Define if the system does not provide POSIX.1 features except
   with this defined.  */
#undef _POSIX_1_SOURCE

/* Define if you need to in order for stat and other things to work.  */
#undef _POSIX_SOURCE

/* Define as the return type of signal handlers (int or void).  */
#define RETSIGTYPE void

/* Define to `unsigned' if <sys/types.h> doesn't define.  */
#undef size_t

/* Define if you have the ANSI C header files.  */
#define STDC_HEADERS 1

/* Define if you can safely include both <sys/time.h> and <time.h>.  */
#undef TIME_WITH_SYS_TIME

/* Define if you have the <stdlib.h> header file.  */
#define HAVE_STDLIB_H 1

/* Define if you have the _doprintf function.  */
#undef HAVE__DOPRINTF

/* Define if you have the fseeko function.  */
#undef HAVE_FSEEKO

/* Define if you have the isascii function.  */
#define HAVE_ISASCII 1

/* Define if you have the memchr function.  */
#define HAVE_MEMCHR 1

/* Define if you have the memcmp function.  */
#define HAVE_MEMCMP 1

/* Define if you have the mkdir function.  */
#define HAVE_MKDIR 1

/* Define if you have the mktemp function.  */
#define HAVE_MKTEMP 1

/* Define if you have the pathconf function.  */
#define HAVE_PATHCONF 0 /* VMS has this, but no need to use it (see addext.c) */

/* Define if you have the raise function.  */
#define HAVE_RAISE 1

/* Define if you have the rename function.  */
#define HAVE_RENAME 1  /* but wrapped because of incompatibility */

/* Define if you have the rmdir function.  */
#define HAVE_RMDIR ((__CRTL_VER >= 70000000) && !LINK_TARGET_PRE7)

/* Define if you have the setmode function.  */
#undef HAVE_SETMODE

/* Define if you have the sigaction function.  */
#define HAVE_SIGACTION  ((__CRTL_VER >= 70000000) && !LINK_TARGET_PRE7)

/* Define if you have the sigprocmask function.  */
#define HAVE_SIGPROCMASK  ((__CRTL_VER >= 70000000) && !LINK_TARGET_PRE7)

/* Define if you have the sigsetmask function.  */
#define HAVE_SIGSETMASK  ((__CRTL_VER >= 70000000) && !LINK_TARGET_PRE7)

/* Define if you have the strerror function.  */
#define HAVE_STRERROR 0  /* VMS has this, but error.c wants to define a prototype */

/* Define if you have the <dirent.h> header file.  */
#define HAVE_DIRENT_H  ((__CRTL_VER >= 70000000) && !LINK_TARGET_PRE7)

/* Define if you have the <fcntl.h> header file.  */
#define HAVE_FCNTL_H 1

/* Define if you have the <limits.h> header file.  */
#define HAVE_LIMITS_H 1

/* Define if you have the <ndir.h> header file.  */
#undef HAVE_NDIR_H

/* Define if you have the <string.h> header file.  */
#define HAVE_STRING_H 1

/* Define if you have the <sys/dir.h> header file.  */
#undef HAVE_SYS_DIR_H

/* Define if you have the <sys/ndir.h> header file.  */
#undef HAVE_SYS_NDIR_H

/* Define if you have the <unistd.h> header file.  */
#define HAVE_UNISTD_H 1

/* Define if you have the <utime.h> header file.  */
#undef HAVE_UTIME_H

/* Define if you have the <varargs.h> header file.  */
#define HAVE_VARARGS_H 1

/* Number of bits in a file offset, on hosts where this is settable. */
#undef _FILE_OFFSET_BITS

/* Define to make fseeko etc. visible, on some hosts. */
#undef _LARGEFILE_SOURCE

/* Define if you have the ed editor. */
#undef HAVE_ED

/* Define for large files, on AIX-style hosts. */
#undef _LARGE_FILES

/* Define if compiler has function prototypes */
#define PROTOTYPES 1

/* Define if <inttypes.h> exists, doesn't clash with <sys/types.h>,
   and declares uintmax_t.  */
#undef HAVE_INTTYPES_H

/* Define if struct utimbuf is declared -- usually in <utime.h>.
   Some systems have utime.h but don't declare the struct anywhere.  */
#undef HAVE_STRUCT_UTIMBUF

/* Define if the malloc check has been performed.  */
#define HAVE_DONE_WORKING_MALLOC_CHECK 1

/* Define to rpl_malloc if the replacement function should be used. */
#undef malloc

/* Define if the realloc check has been performed.  */
#define HAVE_DONE_WORKING_REALLOC_CHECK 1

/* Define to rpl_realloc if the replacement function should be used. */
#undef realloc

/* Define if there is a member named d_ino in the struct describing
   directory headers. */
#undef D_INO_IN_DIRENT

/* Here, we define all the things that are different on VMS.  */

#ifdef __VMS

#define initialize_main(argcp, argvp) vms_initialize_main(argcp, argvp)
extern void vms_initialize_main (int *argcp, char ***argvp);

#define utime(pathname,times) my_utime(pathname,times)
/* No prototype here, since this would require struct utimbuf,
   which would require inclusion of time.h */

/* We are using GNU option handling rather than the C RTL, so 
 * we redefine these to avoid collisions with C RTL symbols with 
 * the same names.
 */
#define getopt my_getopt
#define optarg my_optarg
#define optopt my_optopt
#define optind my_optind
#define opterr my_opterr

#define TMPDIR "/sys$scratch"
#define TTY_DEVICE "TT:"
 
/* to avoid duplicate symbol in case-insensitive linker */
#define Fseek Fseek_private

/* Passing Unix-style filenames to the C RTL sometimes causes trouble,
 * so we jacket the following routines and pass them VMS-style names. 
 * These problems are believed to have been resolved by the ECOs 
 * VAXCRT04_062 and ALPCRT04_062, so if you have an up-to-date C RTL
 * you probably don't really need these (though check vmsutil.c for
 * other functionality the jackets may provide).  Unfortunately we
 * need some includes here to be able to prototype.
 */
#include <fcntl.h>
#include <stat.h>
#include <stdio.h>

#define chmod(_fspec, _mode) my_chmod(_fspec, _mode)
int my_chmod (const char *file_spec, mode_t mode); 

#define creat(_fspec, _mode) my_creat(_fspec, _mode)
int my_creat (const char *__file_spec, __mode_t __mode);

#define exit(_status) my_exit(_status)
void my_exit(int _status);

#define fopen(_fspec, _amode) my_fopen(_fspec, _amode)
FILE *my_fopen (const char *file_spec, const char *a_mode);

#define open my_open
int my_open(const char *file_spec, int flags, ...);

#define rename(_oldfspec, _newfspec) my_rename(_oldfspec, _newfspec)
int my_rename   (const char *__old, const char *__new);

#define unlink(_fspec) my_unlink(_fspec)
int my_unlink(const char *__file_spec);

#define stat(_fspec, _buf) my_stat(_fspec, _buf)
int my_stat (const char *file_spec, struct stat *buffer);

#if __CRTL_VER < 70000000
int strncasecmp(const char *s0, const char *s1, size_t n);
#endif

/* disable informational message about time_t declarations in C 6.2 and later */
#if __DECC_VER > 60200000
#  pragma message disable (QUESTCOMPARE1)
#endif

#endif /* ifdef __VMS */
